


var updateReadOnlyState = function(aceEditor, currentData) {
    if( aceEditor ) {
        var isEditing = currentData.isEditing;
        aceEditor.setReadOnly(!isEditing);
        aceEditor.renderer.$cursorLayer.element.style.opacity = isEditing ? 1 : 0;
        $("#" + currentData.id + "-IC-container").toggleClass('read-only', !isEditing);
    }
};



Template.inputCode.onRendered( function() {
    var currentData = Template.currentData();

    var editor = ace.edit(currentData.id + "-IC-ace");
    var isEditing = currentData.isEditing;

    editor.getSession().setMode("ace/mode/javascript");
    editor.setOption("minLines", currentData.minLines || 6);
    editor.setOption("maxLines", currentData.maxLines || 100);
    editor.renderer.setScrollMargin(9, 9, 0, 0);
    editor.setOptions({
        highlightActiveLine: false,
        highlightGutterLine: false
    });

    // if loaded, switch from textarea to ACE,
    // but keep textarea updated so that parent can fetch the current value
    $("#"+currentData.id+"-IC-container").show();
    var textarea = $("#"+currentData.id).hide();
    editor.getSession().on('change', function() {
        textarea.val(editor.getSession().getValue());
    });

    updateReadOnlyState(editor, currentData);

    // save global reference to editor to automatically update read-only state
    window.inputCodeAceEditors = window.inputCodeAceEditors || {};
    window.inputCodeAceEditors[currentData.id] = editor;
});



Template.inputCode.onCreated( function() {
    // automatically refresh readonly-state of the editor
    this.autorun( function() {
        window.inputCodeAceEditors = window.inputCodeAceEditors || {};
        var currentData = Template.currentData();
        var aceEditor = window.inputCodeAceEditors[currentData.id];
        updateReadOnlyState(aceEditor, currentData);
    });
});
