
// TODO: maybe we should pass the state using a hidden input with JSON data, rather than the session
// (see input_code template for example)

var getRecordsFromSession = function() {
    var records = Session.get(Template.currentData().sessionKey) || [];
    // we need to show at least one row
    if( records.length === 0 )
        records.push( {key:"", value: ""} );
    return records;
};

Template.inputStringKeyValueArray.helpers({

    records: function() {
        var records = getRecordsFromSession();
        // compute helpers for HTML template generation
        // NOTE: there's {{@index}} template which can be used to emulate first, but not last (easily)
        records[0].isFirst = true;
        records[records.length-1].isLast = true;
        return records;
    }

});


Template.inputStringKeyValueArray.events({

    'input input[type=text]': function () {
        var sessionKey = Template.currentData().sessionKey;
        var records = [];
        // save text from all inputs to an array
        $("#ISKVA-"+sessionKey+"-table tr").each( function() {
            records.push( {
                key: $(this).find(".ISKVA-textbox-key").val(),
                value: $(this).find(".ISKVA-textbox-value").val()} );
        });
        Session.set(sessionKey, records);
    },

    'click .ISKVA-button-add': function (event) {
        var records = getRecordsFromSession();
        records.splice( parseInt($(event.currentTarget).attr("data-index")) + 1, 0, {key: "", value: ""} );
        Session.set(Template.currentData().sessionKey, records);
    },

    'click .ISKVA-button-delete': function (event) {
        var records = getRecordsFromSession();
        records.splice( $(event.currentTarget).attr("data-index"), 1 );
        Session.set(Template.currentData().sessionKey, records);
    }

});
