
Meteor.subscribe("acts");

Template.actsList.helpers({

    acts: function () {
        return Acts.find();
    }

});


Template.actsList.events({

    'change #demoSelector': function () {
        console.log("#demoSelector changed: " + new Date());
        var index = $("#demoSelector")[0].selectedIndex;
        $("#test-script").text(demos[index].actionJavaScript);
        $("#test-input").text(demos[index].inputJson);
    },

    'click #run': function () {

        if( state.get() === "EXECUTING" )
            return;
        state.set("INITIALIZING");

        // try to parse input JSON
        var inputJson = $("#test-input").val();
        var input = {};
        try {
            if( inputJson.trim().length > 0 )
                input = JSON.parse(inputJson)
        } catch(e) {
            state.set("FAILED");
            Session.set(LAST_ERROR_KEY, "Input JSON cannot be parsed, please check the syntax.");
            return;
        }

        // insert/update act to database
        var act = {
            _id: Session.get(ACT_ID_KEY),
            script: $("#test-script").val()
        };

        Meteor.call("upsertAct", act, function(error, result) {
            if( error ) {
                state.set("FAILED");
                Session.set(LAST_ERROR_KEY, error.toString());
                return;
            }
            act = result;
            Session.set(ACT_ID_KEY, act._id);

            // execute the act
            Meteor.call("executeAct", act._id, input, function (error, result) {
                if( error ) {
                    state.set("FAILED");
                    Session.set(LAST_ERROR_KEY, error.toString());
                    return;
                }
                console.log("executeAct result: " + result);
                Session.set(ACT_EXECUTION_ID_KEY, result);
            });
        });
    }
});