
var ACT_ID_KEY = 'demoActId';
var ACT_EXECUTION_ID_KEY = 'demoActExecutionId';
var LAST_ERROR_KEY = "demoLastError";

Session.setDefault(ACT_ID_KEY, null);
Session.setDefault(ACT_EXECUTION_ID_KEY, null);


Meteor.subscribe("acts");
Tracker.autorun(function () {
    //console.log("autorun resubscribe called: " + Session.get(ACT_EXECUTION_ID_KEY));
    Meteor.subscribe("actExecutionsById", Session.get(ACT_EXECUTION_ID_KEY));
});

// gets the current ActExecution instance
var getActExecution = function() {
    //console.log("getActExecution() start");
    var actExecutionId = Session.get(ACT_EXECUTION_ID_KEY);
    if (!actExecutionId)
        return null;

    //find(selector, options).fetch()[0] with options.limit = 1.

    var actExecution = ActExecutions.findOne(actExecutionId); //.fetch()[0];
    //console.log("getActExecution(): " + actExecution);
    if( !actExecution || actExecution.actId!==Session.get(ACT_ID_KEY) )
        return null;
    return actExecution;
};

// variable representing the current state of execution
var state = new ReactiveVar("READY");
Tracker.autorun(function () {
    //console.log("HEREEE AUTORUN");
    var actExecution = getActExecution();
    if (!actExecution)
        state.set("READY");
    else if (actExecution.endDate && actExecution.exitCode===0)
        state.set("FINISHED");
    else if (actExecution.endDate ) {
        state.set("FAILED");
        Session.set(LAST_ERROR_KEY, "Actor process exited with a non-zero exit code: " + actExecution.exitCode);
    }
    else
        state.set("RUNNING");
});

/*
// auto-scroll console to bottom
// SEE http://stackoverflow.com/questions/18614301/keep-overflow-div-scrolled-to-bottom-unless-user-scrolls-up
//var isAutoScrolling = false;
setInterval( function() {
    if ($('#autoScroll').is(':checked') && $("#console").val()!="" ) {
        //isAutoScrolling = true;
        $("#console").get(0).scrollTop = $("#console").get(0).scrollHeight;
        //setTimeout( function(){
        //    isAutoScrolling = false;
        //}, 10);
    }
}, 500);*/


var demos = [
    {
        name: "select...",
        actionJavaScript: '',
        inputJson: ''
    },
    {
        name: "CHECK CAR HISTORY USING VIN CODE",
        actionJavaScript:
            'exports.crawlerConfig = {\n'
            + '    id: "cebia.js",\n'
            + '    startUrls: [ "https://www.zkontrolujsiauto.cz/?s_vin=WF0GXXGBBG7Y42388&lang=1" ],\n'
            + '    searchAreaPurls: [ "https://www.zkontrolujsiauto.cz/?s_vin=WF0GXXGBBG7Y42388&lang=1" ],\n'
            + '    targetPagePurls: [ "https://www.zkontrolujsiauto.cz/?s_vin=WF0GXXGBBG7Y42388&lang=1" ],\n'
            + '    injectJQuery: true,\n'
            + '    pageFunction: function pageFunction(context) {\n'
            + '        var $ = context.jQuery;\n'
            + '        var request = context.request;\n'
            + '        var result = {};\n'
            + '        result.vin = $(" .vin-number").text().trim().substring(5);\n'
            + '        result.make = $(" .car-info .feature:eq(0) .content").text().trim();\n'
            + '        result.model = $(" .car-info .feature:eq(1) .content").text().trim();\n'
            + '        result.type = $(" .car-info .feature:eq(2) .content").text().trim();\n'
            + '        result.usage = $(" .car-info .feature:eq(3) .content").text().trim();\n'
            + '        result.fuel = $(" .car-info .feature:eq(4) .content").text().trim();\n'
            + '        result.power = $(" .car-info .feature:eq(5) .content").text().trim();\n'
            + '        result.engine = $(" .car-info .feature:eq(6) .content").text().trim();\n'
            + '        return result;\n'
            + '    }\n'
            + '};\n'
            + '\n'
            + 'exports.actorActions = {\n'
            + '\n'
            + '    casperOptions: {\n'
            + '        verbose: false,\n'
            + '        logLevel: "info",\n'
            + '        pageSettings: {\n'
            + '            loadImages: false\n'
            + '        }\n'
            + '    },\n'
            + '\n'
            + '    defaultAction: function getCarData(context) {\n'
            + '        var casper = context.casper;\n'
            + '        var output = context.output;\n'
            + '        var input = context.input;\n'
            + '\n'
            + '        var url = "https://www.zkontrolujsiauto.cz/?s_vin=" + input.vin + "&lang=1";\n'
            + '\n'
            + '        casper.thenOpen(url);\n'
            + '        casper.thenWaitForSelector(".car-info");\n'
            + '        casper.thenCapture(context.nextFileFromPattern("/tmp/cebia_%(random).png"));\n'
            + '        casper.then(function getCarData2() {\n'
            + '            output.carData = context.invokePageFunction(exports.crawlerConfig);\n'
            + '        });\n'
            + '    }\n'
            + '};\n',
        inputJson: '{ "vin": "WF0GXXGBBG7Y42388" }'},
    {
        name: "BUY PRODUCTS FROM ONLINE STORE",
        actionJavaScript:
            '// phantomjs crawler.js ./config/qclothing_co_uk.js --out=outputs/qclothing_co_uk_Crawler.json\n'
            + 'exports.crawlerConfig = {\n'
            + '	id: "qclothing.co.uk",\n'
            + '	startUrls: [\n'
            + '		"http://www.qclothing.co.uk/women",\n'
            + '		"http://www.qclothing.co.uk/men",\n'
            + '		"http://www.qclothing.co.uk/children/girls",\n'
            + '		"http://www.qclothing.co.uk/children/boys",\n'
            + '		"http://www.qclothing.co.uk/footwear",\n'
            + '		"http://www.qclothing.co.uk/women/accessories",\n'
            + '	],\n'
            + '	searchAreaPurls: [\n'
            + '		"http://www.qclothing.co.uk/women?p=[\\\\d{1,5}]",\n'
            + '		"http://www.qclothing.co.uk/men?p=[\\\\d{1,5}]",\n'
            + '		"http://www.qclothing.co.uk/children/girls?p=[\\\\d{1,5}]",\n'
            + '		"http://www.qclothing.co.uk/children/boys?p=[\\\\d{1,5}]",\n'
            + '		"http://www.qclothing.co.uk/footwear?p=[\\\\d{1,5}]",\n'
            + '		"http://www.qclothing.co.uk/women/accessories?p=[\\\\d{1,5}]" ],\n'
            + '	targetPagePurls: [\n'
            + '		"http://www.qclothing.co.uk/[([0-9]|[a-z]|-)+]" ],\n'
            + '	maxCrawledPages: 10000,\n'
            + '	maxOutputPages: 2000,\n'
            + '	randomWaitBetweenRequests: { mean: 200, stdev: 50 },\n'
            + '	injectJQuery: true,\n'
            + '	injectClientScripts: [\n'
            + '		"./config/_shoppingutils.js"\n'
            + '	],\n'
            + '	pageFunction: function pageFunction( context ) {\n'
            + '		var $             = context.jQuery;\n'
            + '		var request       = context.request;\n'
            + '		var shoppingUtils = new window.ShoppingUtils();\n'
            + '		var result        = {};\n'
            + '		\n'
            + '		// on this website, product category depends on which page the product page was opened from,\n'
            + '		// therefore we compose the category from the pages that led to product page\n'
            + '		// TODO: use referring requests !!!\n'
            + '		result.category = [];\n'
            + '		$(".breadcrumbs li").each( function() {\n'
            + '			if( $(this).attr("class").startsWith("category") ) {\n'
            + '				var text = $(this).find("a, strong").text();\n'
            + '				if( text ) {\n'
            + '					result.category.push( text );\n'
            + '				}\n'
            + '			}\n'
            + '		});\n'
            + '		if( !request.matchesTargetPage ) {\n'
            + '			return result;\n'
            + '		}\n'
            + '		\n'
            + '		result.productTitle = $(".product-shop h1").text().trim();		\n'
            + '		result.localUniqueId = $(".product-shop .product-code strong").text().trim();\n'
            + '		\n'
            + '		// find product price (must be float!)\n'
            + '		var priceRegular = $(".product-shop .per-pack .regular-price .price").text().trim();\n'
            + '		var priceDiscounted = $(".product-shop .per-pack .special-price .price").text().trim();\n'
            + '		var priceAsText = priceDiscounted || priceRegular;\n'
            + '		// priceAsText must be GBP currency symbol followed by a number!\n'
            + '		var priceParsed = shoppingUtils.parsePrice(priceAsText);\n'
            + '		if( priceParsed ) {\n'
            + '			result.price = priceParsed.price;\n'
            + '			result.priceCurrency = priceParsed.currencyCode;\n'
            + '		}\n'
            + '		\n'
            + '		result.productDescription = $(".product-shop .short-description").text().trim();\n'
            + '		result.productDescriptionHtml = $(".product-shop .short-description").html();\n'
            + '\n'
            + '        var variant = {};\n'
            + '		\n'
            + '		// find number of items in stock (must be integer!)\n'
            + '		var availabilityText = $(".product-shop .availability").text().trim();\n'
            + '		var match = availabilityText.match(/In stock - (\d+) Pack/i);\n'
            + '		if( match && match.length >= 2 ) {\n'
            + '            variant.itemsInStock = parseInt(match[1]);\n'
            + '		} else if( availabilityText == "Out of stock" ) {\n'
            + '            variant.itemsInStock = 0;\n'
            + '		} else {\n'
            + '			// use a negative number to indicate unexpected value !\n'
            + '            variant.itemsInStock = -1;\n'
            + '		}\n'
            + '        variant.itemsInStockAtLeast = variant.itemsInStockAtLeast;\n'
            + '        variant.key = "default";\n'
            + '\n'
            + '        result.variants = [ variant ];\n'
            + '		\n'
            + '		// get photos\n'
            + '		// TODO: download whole pictures, not just URLs\n'
            + '		result.photoUrls = [];\n'
            + '		$(".product-view .zoom-gallery .slide a").each( function() {\n'
            + '			result.photoUrls.push( $(this).attr("href") );\n'
            + '		});\n'
            + '		\n'
            + '		return result;\n'
            + '	}\n'
            + '};\n'
            + '\n'
            + '// /Applications/XAMPP/htdocs/Crawler/Source/casperjs/bin/casperjs actor-debug.js ./config/qclothing_co_uk.js submitOrder --input=../Tests/qclothing_order_in.json --output=outputs/qclothing_co_uk_Actor.json\n'
            + 'exports.actorActions = {\n'
            + '\n'
            + '	casperOptions: {\n'
            + '		verbose: true,\n'
            + '		logLevel: "debug"\n'
            + '	},\n'
            + '\n'
            + '    defaultAction: function submitOrder(context) {\n'
            + '		\n'
            + '		var shoppingUtils = require("../config/_shoppingutils").create();\n'
            + '		var casper        = context.casper;\n'
            + '		var input         = context.input;\n'
            + '		var output        = context.output;\n'
            + '				\n'
            + '		// save results of crawler"s "pageFunction" for each of the product pages as a reference\n'
            + '		output.currentProductDetails = [];\n'
            + '		\n'
            + '		// open product pages and add items to cart\n'
            + '		input.products.forEach( function addToCart(product) {\n'
            + '			casper.thenOpenOrFail(product.url);\n'
            + '			casper.thenWaitForSelector("form#product_addtocart_form");\n'
            + '			casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "productDetails") );			\n'
            + '			casper.then( function addToCart2() {\n'
            + '				// check the current product details are as expected\n'
            + '				var currentProduct = context.invokePageFunction(exports.crawlerConfig);\n'
            + '				shoppingUtils.ensureSameProduct( product, currentProduct );\n'
            + '				output.currentProductDetails.push( currentProduct );\n'
            + '			});\n'
            + '			casper.thenFillSelectors("form#product_addtocart_form", {"input#qty": input.quantity}, true);			\n'
            + '			casper.thenWaitForText("was added to your shopping cart");\n'
            + '			casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "addToCart") );\n'
            + '		});\n'
            + '		\n'
            + '		// open CHECKOUT page\n'
            + '		casper.thenOpenOrFail("http://www.qclothing.co.uk/checkout/onepage/");\n'
            + '		casper.thenClickOrFail( "input[name=checkout_method][value=guest]" );		\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "checkout") );\n'
            + '		casper.thenClickOrFail( "button#onepage-guest-register-button" );\n'
            + '		casper.thenWait( 3000 );\n'
            + '		\n'
            + '		// fill BILLING INFORMATION form\n'
            + '		casper.thenFillSelectors("form#co-billing-form", {\n'
            + '				"input#billing\\\\:firstname":   input.billingInfo.firstName,\n'
            + '				"input#billing\\\\:lastname":    input.billingInfo.lastName,\n'
            + '				"input#billing\\\\:email":       input.billingInfo.email,\n'
            + '				"input#billing\\\\:street1":     input.billingInfo.streetAddress,\n'
            + '				"input#billing\\\\:city":        input.billingInfo.city,\n'
            + '				"input#billing\\\\:postcode":    input.billingInfo.postCode,\n'
            + '				"select#billing\\\\:country_id": input.billingInfo.countryCode,\n'
            + '				"input#billing\\\\:telephone":   input.billingInfo.phone});\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "billingInfo") );\n'
            + '		casper.thenClickOrFail("#billing-buttons-container button[title=Continue]");\n'
            + '		casper.thenWait(3000);\n'
            + '		\n'
            + '		// fill SHIPPING INFORMATION form\n'
            + '		casper.thenFillSelectors("form#co-shipping-form", {\n'
            + '				"input#shipping\\\\:firstname":   input.shippingInfo.firstName,\n'
            + '				"input#shipping\\\\:lastname":    input.shippingInfo.lastName,\n'
            + '				"input#shipping\\\\:street1":     input.shippingInfo.streetAddress,\n'
            + '				"input#shipping\\\\:city":        input.shippingInfo.city,\n'
            + '				"input#shipping\\\\:postcode":    input.shippingInfo.postCode,\n'
            + '				"select#shipping\\\\:country_id": input.shippingInfo.countryCode,\n'
            + '				"input#shipping\\\\:telephone":   input.shippingInfo.phone});				\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "shippingInfo") );\n'
            + '		casper.thenClickOrFail("#shipping-buttons-container button[title=Continue]");\n'
            + '		casper.thenWait(3000);\n'
            + '		\n'
            + '		// fill SHIPPING METHOD form\n'
            + '		casper.thenClickOrFail("input[type=radio]#s_method_premiumrate_Special_Rate");\n'
            + '		casper.thenWait(1000);\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "shippingMethod") );\n'
            + '		casper.thenClickOrFail("#shipping-method-buttons-container button");\n'
            + '		casper.thenWait(3000);\n'
            + '		\n'
            + '		// fill PAYMENT INFORMATION form\n'
            + '		// TODO: for credit card type, we"ll need to hard-code a mapping between select values and our types!!!\n'
            + '		var cardType = null;\n'
            + '		switch( input.paymentCreditCard.type ) {\n'
            + '			case "VISA": cardType = "VISA"; break;\n'
            + '			case "MASTERCARD": cardType = "MC"; break;\n'
            + '			case "DELTA": cardType = "DELTA"; break;\n'
            + '			case "SOLO": cardType = "SOLO"; break;\n'
            + '			case "MAESTRO_UK": cardType = "SWITCH"; break;\n'
            + '			case "VISA_ELECTRON": cardType = "UKE"; break;\n'
            + '		}\n'
            + '		if( !cardType ){\n'
            + '			throw "Unknown card type!";\n'
            + '		}\n'
            + '		casper.thenClickOrFail("#p_method_sagepaydirectpro");\n'
            + '		casper.thenWait(1000);\n'
            + '		casper.thenFillSelectors("form#co-payment-form", {\n'
            + '				"input#sagepaydirectpro_cc_owner":       input.paymentCreditCard.fullName,\n'
            + '				"select#sagepaydirectpro_cc_type":       cardType,\n'
            + '				"input#sagepaydirectpro_cc_number":      input.paymentCreditCard.number,\n'
            + '				"select#sagepaydirectpro_expiration":    input.paymentCreditCard.expirationMonth,\n'
            + '				"select#sagepaydirectpro_expiration_yr": input.paymentCreditCard.expirationYear,\n'
            + '				"input#sagepaydirectpro_cc_cid":         input.paymentCreditCard.securityCode} );\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "paymentInfo") );\n'
            + '		casper.thenClickOrFail("#payment-buttons-container button");\n'
            + '		casper.thenWait(3000);\n'
            + '		casper.thenCapture( context.nextFileFromPattern(input.screenshotFilesPattern, "final") );\n'
            + '	}\n'
            + '};\n',
        inputJson:
            '{\n'
            + '  "orderId" : "123456",\n'
            + '  "screenshotFilesPattern": "/tmp/qclothing_order_on/_%(random)_%(step)_%(customText).png",\n'
            + '  "totalPrice": 243.5,\n'
            + '  "totalPriceCurrency": "GBP",\n'
            + '  "products": [\n'
            + '  {\n'
            + '    "url": "http://www.qclothing.co.uk/hello-kitty-girls-dress-10-pack-9073",\n'
            + '    "localUniqueId": "GDRE0005",\n'
            + '	"quantity": 2,\n'
            + '	"price": 30,\n'
            + '	"priceCurrency": "GBP",\n'
            + '    "variantKey": "default"\n'
            + '  },\n'
            + '  {\n'
            + '    "url": "http://www.qclothing.co.uk/disney-doc-mcstuffins-girls-socks-9-pack-9064",\n'
            + '    "localUniqueId": "CHI2637",\n'
            + '    "quantity": 1,\n'
            + '	"price": 3.50,\n'
            + '	"priceCurrency": "GBP",\n'
            + '    "variantKey": "default"\n'
            + '  }],\n'
            + '  "billingInfo": {\n'
            + '    "firstName": "Jan",\n'
            + '    "lastName": "Curn",\n'
            + '    "email": "jan.curn@gmail.com",\n'
            + '    "streetAddress": "Street 123",\n'
            + '    "city": "Prague",\n'
            + '    "postCode": "14700",\n'
            + '    "country": "Czech republic",\n'
            + '    "countryCode": "CZ",\n'
            + '    "phone": "+420775253782"\n'
            + '  },\n'
            + '  "shippingInfo": {\n'
            + '    "firstName": "Jan",\n'
            + '    "lastName": "Curn",\n'
            + '    "email": "jan.curn@gmail.com",\n'
            + '    "streetAddress": "Street 123",\n'
            + '    "city": "Prague",\n'
            + '    "postCode": "14700",\n'
            + '    "country": "Czech republic",\n'
            + '    "countryCode": "CZ",\n'
            + '    "phone": "+420775253782"\n'
            + '  },\n'
            + '  "paymentCreditCard": {\n'
            + '    "fullName": "Jan Curn",\n'
            + '    "number": "1234567890123456",\n'
            + '    "type": "MASTERCARD",\n'
            + '    "expirationYear": "2017",\n'
            + '    "expirationMonth": "12",\n'
            + '    "securityCode": "627"\n'
            + '  }\n'
            + '}'
    }];


Template.demo.helpers({

    demos: function() { return demos; },

    act: function () {
        var actId = Session.get(ACT_ID_KEY);
        if (!actId)
            return null;
        return Acts.findOne(actId);
    },

    actExecution: function() {
        return getActExecution();
    },

    status: function () {
        switch(state.get()) {
            case "READY":        return "Ready";
            case "INITIALIZING": return "Initializing";
            case "RUNNING":      return "Running";
            case "FINISHED":     return "Finished";
            case "FAILED":       return "Failed: " + Session.get(LAST_ERROR_KEY);
            default:             return "";
        }
    },

    controlAttrDisabled: function () {
        return state.get() === "RUNNING" ? "disabled" : "";
    },

    lastScreenshotUrl: function() {
        var actExecution = getActExecution();
        if( !actExecution || !actExecution.checkpoints )
            return "";
        var last = "";
        //console.log("XXXX: " + actExecution.checkpoints.length);
        _.each(actExecution.checkpoints, function(checkpoint) {
            if( checkpoint.screenshotFileId )
                last = checkpoint.screenshotFileId;
        });
        //console.log("XXXXFFFFF: " + last);
        if( last )
            last = "http://localhost:1234/files/" + last;
        return last;
    }
});


Template.demo.events({

    'change #demoSelector': function () {
        console.log("#demoSelector changed: " + new Date());
        var index = $("#demoSelector")[0].selectedIndex;
        $("#test-script").text(demos[index].actionJavaScript);
        $("#test-input").text(demos[index].inputJson);
    },

    'click #run': function () {

        if( state.get() === "EXECUTING" )
            return;
        state.set("INITIALIZING");

        // try to parse input JSON
        var inputJson = $("#test-input").val();
        var input = {};
        try {
            if( inputJson.trim().length > 0 )
                input = JSON.parse(inputJson)
        } catch(e) {
            state.set("FAILED");
            Session.set(LAST_ERROR_KEY, "Input JSON cannot be parsed, please check the syntax.");
            return;
        }

        // insert/update act to database
        var act = {
            _id: Session.get(ACT_ID_KEY),
            type: 'script',
            customId: 'Demo_' + Math.floor(Math.random() * 100000000),
            script: $("#test-script").val()
        };

        Meteor.call("upsertAct", act, function(error, result) {
            if( error ) {
                state.set("FAILED");
                Session.set(LAST_ERROR_KEY, error.toString());
                return;
            }
            act = result;
            Session.set(ACT_ID_KEY, act._id);

            // execute the act
            Meteor.call("executeAct", act._id, input, function (error, result) {
                if( error ) {
                    state.set("FAILED");
                    Session.set(LAST_ERROR_KEY, error.toString());
                    return;
                }
                console.log("executeAct result: " + result);
                Session.set(ACT_EXECUTION_ID_KEY, result);
            });
        });
    },

    /*'scroll #console': function () {
        if( !isAutoScrolling )
            $("#autoScroll").prop("checked", false);
    }*/
});