
/// NEW STUFF FROM BOILERPLATE


Router.configure({
    layoutTemplate: 'masterLayout',
    loadingTemplate: 'spinner',
    notFoundTemplate: 'pageNotFound',
    yieldTemplates: {
        nav: {to: 'nav'},
        footer: {to: 'footer'},
    },

    // wait on the following subscriptions before rendering the page to ensure
    // the data it's expecting is present
    waitOn: function() {
        return [
            Meteor.subscribe('acts')
        ];
    }
});


// routes

//Router.route('/', {
//    name: 'home',
//    template: 'home'
//});



var renderTemplate = function (self, templateName) {
    self.layout('masterLayout');
    self.render('nav', {to: 'nav'});
    self.render('footer', {to: 'footer'});
    self.render(templateName);
};


Router.route('/', function () {
    // show acts for logged users and demo for non-logged
    if( Meteor.userId() )
        this.redirect('/acts');
    else
        renderTemplate(this, Meteor.userId() );
}, { name: 'home' });


Router.route('/demo');

Router.route('/acts',                 function() { renderTemplate(this, 'actsList');   },    {name: 'actsList'}       );
// make sure this route is BEFORE route '/acts/:actId' !!!
Router.route('/acts/new-:newActType', function() { renderTemplate(this, 'actDetails'); },    {name: 'actNew'}       );
Router.route('/acts/:actId',          function() { renderTemplate(this, 'actDetails'); },    {name: 'actView'}      );
Router.route('/acts/:actId/edit',     function() { renderTemplate(this, 'actDetails'); },    {name: 'actEdit'}      );
Router.route('/page-not-found/:code', function() { renderTemplate(this, 'pageNotFound'); },  {name: 'pageNotFound'} );


Router.route('/terms-of-use',         function() { renderTemplate(this, 'termsOfUse'); },    {name: 'termsOfUse'} );
Router.route('/privacy-policy',       function() { renderTemplate(this, 'privacyPolicy'); }, {name: 'privacyPolicy'} );



Router.plugin('ensureSignedIn', {
    only: ['acts']
});

AccountsTemplates.configureRoute('changePwd');
AccountsTemplates.configureRoute('enrollAccount');
AccountsTemplates.configureRoute('forgotPwd');
AccountsTemplates.configureRoute('resetPwd');
AccountsTemplates.configureRoute('signIn');
AccountsTemplates.configureRoute('signUp');
AccountsTemplates.configureRoute('verifyEmail');






// GLOBAL SETTINGS
///////////////////


/*

Router.onBeforeAction( function() {
    // show loading page while logging in
    if(Meteor.loggingIn()) {
        this.render(this.loadingTemplate);
        this.stop();
    } else {
        this.next();
    }
});


// ROUTES
//////////

Router.route('/', {
    name: 'frontpage',
    template: 'frontpage',
    onBeforeAction: function () {
        // if logged in, show acts
        if (Meteor.user() && !Meteor.loggingIn())
            this.redirect('acts');
        else
            this.next();
    }
});

Router.route('/demo', {
    name: 'demo',
    template: 'demo'
});


var ensureLoggedIn = function() {
    if (!Meteor.userId()) {
        this.render('login');
        return pause();
    } else
        this.next();
};

Router.route('/acts', function() {
        this.layout('defaultLayout');
        this.render('acts');
    }, {
        name: 'acts',
        onBeforeAction: ensureLoggedIn
});

Router.route('/act/:_id', {
    name: 'act',
    template: 'act',
    onBeforeAction: ensureLoggedIn
});

    */